unit PageSetupFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Borland.Vcl.StdCtrls, System.ComponentModel, Borland.Vcl.Buttons,
  Borland.Vcl.ExtCtrls,CAD, Borland.Vcl.ExtDlgs, Borland.Vcl.Spin;

type
  TPageSetupForm = class(TForm)
    bbClose: TBitBtn;
    gbPage: TGroupBox;
    clrPageColor: TColorBox;
    lblPageColor: TLabel;
    cbPageStyle: TComboBox;
    lblPageStyle: TLabel;
    gbBackground: TGroupBox;
    Panel1: TPanel;
    Image1: TImage;
    lblPosition: TLabel;
    cbPosition: TComboBox;
    btnLoad: TButton;
    btnClear: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    gbGridOperation: TGroupBox;
    seSnapPixel: TSpinEdit;
    lblSnapPixel: TLabel;
    seGridWidth: TSpinEdit;
    lblGridWidth: TLabel;
    lblGridHeight: TLabel;
    seGridHeight: TSpinEdit;
    gbDimension: TGroupBox;
    lblUnit: TLabel;
    cbUnit: TComboBox;
    lblRatio: TLabel;
    edtRatio: TEdit;
    Label1: TLabel;
    btnSetup: TButton;
    procedure btnSetupClick(Sender: TObject);
    procedure cbUnitChange(Sender: TObject);
    procedure seSnapPixelChange(Sender: TObject);
    procedure seGridWidthChange(Sender: TObject);
    procedure seGridHeightChange(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure btnLoadClick(Sender: TObject);
    procedure cbPositionChange(Sender: TObject);
    procedure cbPageStyleChange(Sender: TObject);
    procedure clrPageColorChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure bbCloseClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PageSetupForm: TPageSetupForm;

implementation

uses MainFrm;

{$R *.nfm}

procedure TPageSetupForm.bbCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TPageSetupForm.FormShow(Sender: TObject);
begin

  clrPageColor.Selected:=MainForm.MyCAD1.ColorOfBackground;

  cbPageStyle.ItemIndex:=Convert.ToInt32((MainForm.MyCAD1.PageStyle));

  cbPosition.ItemIndex:=Convert.ToInt32((MainForm.MyCAD1.BkBitmapMode));

  seSnapPixel.Value:=MainForm.MyCAD1.SnapPixels;

  seGridWidth.Value:=MainForm.MyCAD1.GridOperation.GridWidth;
  seGridHeight.Value:=MainForm.MyCAD1.GridOperation.GridHeight;

  cbUnit.ItemIndex:=Convert.ToInt32((MainForm.MyCAD1.TheUNIT));

  edtRatio.Text:=FloatToStr(Round(MainForm.MyCAD1.Ratio*100));
end;

procedure TPageSetupForm.clrPageColorChange(Sender: TObject);
begin
  MainForm.MyCAD1.ColorOfBackground:=clrPageColor.Selected;
end;

procedure TPageSetupForm.cbPageStyleChange(Sender: TObject);
begin
  MainForm.MyCAD1.PageStyle:=TPageStyle(cbPageStyle.ItemIndex);
  MainForm.AdjustMyCAD;
end;

procedure TPageSetupForm.cbPositionChange(Sender: TObject);
begin
  MainForm.MyCAD1.BkBitmapMode:=TBkBitmapMode(cbPosition.ItemIndex);
end;

procedure TPageSetupForm.btnLoadClick(Sender: TObject);
var
  MyBitmap: TBitmap;
begin
  if OpenPictureDialog1.Execute then
  begin
    MyBitmap := TBitmap.Create;
    MyBitmap.LoadFromFile(OpenPictureDialog1.FileName);
    MainForm.MyCAD1.BkBitmap:=MyBitmap;
    Image1.Picture.LoadFromFile(OpenPictureDialog1.FileName);
    MyBitmap.Free;
  end;
end;

procedure TPageSetupForm.btnClearClick(Sender: TObject);
begin
  MainForm.MyCAD1.BkBitmap:=nil;
  Image1.Picture:=nil;
end;

procedure TPageSetupForm.Image1Click(Sender: TObject);
begin
  btnLoadClick(Sender);
end;

procedure TPageSetupForm.seGridHeightChange(Sender: TObject);
begin
  MainForm.MyCAD1.GridOperation.GridHeight:=seGridHeight.Value;
end;

procedure TPageSetupForm.seGridWidthChange(Sender: TObject);
begin
  MainForm.MyCAD1.GridOperation.GridWidth:=seGridWidth.Value;
end;

procedure TPageSetupForm.seSnapPixelChange(Sender: TObject);
begin
  MainForm.MyCAD1.SnapPixels:=seSnapPixel.Value;
end;

procedure TPageSetupForm.cbUnitChange(Sender: TObject);
begin
  MainForm.MyCAD1.TheUNIT:=TUnits(cbUnit.ItemIndex);
end;

procedure TPageSetupForm.btnSetupClick(Sender: TObject);
begin
  try
    MainForm.MyCAD1.Ratio:=StrToInt(edtRatio.text) / 100.0
  except
  end;
end;

end.
