unit PrintPreviewFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Borland.Vcl.StdCtrls, Borland.Vcl.ExtCtrls, System.ComponentModel,
  Math, Borland.Vcl.Buttons;

type
  TPrintPreviewForm = class(TForm)
    Panel1: TPanel;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    cbZoom: TComboBox;
    bbPrintCurrentLayer: TBitBtn;
    bbPrint: TBitBtn;
    procedure bbPrintClick(Sender: TObject);
    procedure bbPrintCurrentLayerClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure cbZoomChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    TheScale:Double;
    procedure AdjustPosition;
  end;

var
  PrintPreviewForm: TPrintPreviewForm;

implementation

uses MainFrm;

{$R *.nfm}

procedure TPrintPreviewForm.AdjustPosition;
begin
  Scrollbox1.HorzScrollBar.Position := 0;
  Scrollbox1.VertScrollBar.Position := 0;

  PrintPreviewForm.Image1.Width := PrintPreviewForm.Image1.picture.Bitmap.width;
  PrintPreviewForm.Image1.Height := PrintPreviewForm.Image1.picture.Bitmap.Height;
  if Image1.Width < ScrollBox1.Width then
    Image1.Left := (ScrollBox1.Width - Image1.Width) div 2
  else
    Image1.Left := 0;

  if Image1.Height < ScrollBox1.Height then
    Image1.Top := (ScrollBox1.Height - Image1.Height) div 2
  else
    Image1.Top := 0;

  Scrollbox1.HorzScrollBar.Range := max(Image1.Width, ScrollBox1.Width);
  Scrollbox1.VertScrollBar.Range := max(Image1.Height, ScrollBox1.Height);

  Scrollbox1.ScrollInView(Image1);
end;

procedure TPrintPreviewForm.cbZoomChange(Sender: TObject);
var
  ScaleX, ScaleY: double;
begin
  with cbZoom do
  begin
    case ItemIndex of
      0: TheScale := 0.5;
      1: TheScale := 1.0;
      2: TheScale := 1.5;
      3: TheScale := 2.0;
      4: {Page Width}
        TheScale := ScrollBox1.Width / MainForm.mycad1.width;
      5: {Whole Page}
        begin
          ScaleX := ScrollBox1.Width / MainForm.mycad1.Width;
          ScaleY := ScrollBox1.Height / MainForm.mycad1.Height;
          if (ScaleX <= ScaleY) then
            TheScale := ScaleX
          else
            TheScale := ScaleY;
        end;

      6: TheScale := 1.0;
    end;

    MainForm.MyCAD1.PrintPreview([],Image1.Picture.Bitmap, TheScale * 0.9);
    AdjustPosition;
  end;
end;

procedure TPrintPreviewForm.FormResize(Sender: TObject);
begin
  cbZoomChange(Sender);
end;

procedure TPrintPreviewForm.bbPrintCurrentLayerClick(Sender: TObject);
begin
  MainForm.MyCAD1.Print([MainForm.MyCAD1.CurrentLayerId], 1.0);
end;

procedure TPrintPreviewForm.bbPrintClick(Sender: TObject);
begin
  MainForm.MyCAD1.Print([],1.0);
end;

end.
